=== docs/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile --output-file=requirements.txt requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.12.1
    # via sphinx
beautifulsoup4==4.12.2
    # via exhale
breathe==4.35.0
    # via
    #   -r requirements.in
    #   exhale
certifi==2024.7.4
    # via requests
charset-normalizer==3.2.0
    # via requests
docutils==0.17.1
    # via
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx
    #   sphinx-rtd-theme
exhale==0.3.6
    # via -r requirements.in
idna==3.7
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.5
    # via
    #   myst-parser
    #   sphinx
lxml==4.9.3
    # via exhale
markdown-it-py==2.2.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.3
    # via jinja2
mdit-py-plugins==0.3.5
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-parser==0.18.1
    # via -r requirements.in
packaging==23.1
    # via sphinx
pygments==2.16.1
    # via sphinx
pyyaml==6.0.1
    # via myst-parser
requests==2.32.0
    # via sphinx
six==1.16.0
    # via exhale
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.4.1
    # via beautifulsoup4
sphinx==4.5.0
    # via
    #   -r requirements.in
    #   breathe
    #   exhale
    #   myst-parser
    #   sphinx-rtd-theme
    #   sphinxcontrib-jquery
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.4
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.1
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
typing-extensions==4.7.1
    # via myst-parser
urllib3==2.2.2
    # via requests
