=== debian/changelog ===
libzeep (6.1.1-1) experimental; urgency=medium

  * New upstream version 6.1.1
  * Added copyright statements

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 09 Feb 2025 13:07:43 +0100

libzeep (6.1.0-1) experimental; urgency=medium

  [ Andreas Tille ]
  * Fix clean target Closes: #1046447

  [ Maarten L. Hekkelman ]
  * New upstream version 6.1.0
  * remove patches

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 05 Feb 2025 11:42:39 +0100

libzeep (6.0.6-1) experimental; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.0 (routine-update)
  * Drop transition for old debug package migration.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 22 Aug 2023 09:54:23 +0200
