=== debian/control ===
Source: libzeep
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
			   cmake,
			   libboost-dev,
			   libhowardhinnant-date-dev,
			   libmcfp-dev,
			   mrc,
			   doxygen,
			   python3-exhale,
               python3-sphinx-rtd-theme,
               python3-myst-parser
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/libzeep
Vcs-Git: https://salsa.debian.org/med-team/libzeep.git
Homepage: https://github.com/mhekkel/libzeep
Rules-Requires-Root: no

Package: libzeep-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libzeep6 (= ${binary:Version}),
         libboost-dev,
         libhowardhinnant-date-dev,
         cmake
Suggests: libzeep-doc, mrc
Description: Development files for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This specific package contains all files needed to develop new
 software using libzeep.

Package: libzeep-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: libzeep-dev (>= ${binary:Version})
Description: Documentation for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This specific package contains the documentation you can use to develop new
 software using libzeep.

Package: libzeep6
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library file for libzeep
 Libzeep is a C++ library providing a validating XML parser, XML DOM tree
 implementation, XPath 1.0 support and code to create SOAP/REST servers as
 well as a full web application framework.
 .
 libzeep was originally designed to create SOAP servers in C++ easily. The
 current incarnation provides a full validating XML parser creating a DOM tree
 that can be iterated using STL container like methods. The tree can be searched
 using XPath 1.0 queries.
 .
 There's also code to create SOAP and REST servers based allowing to export
 C++ methods as web services. And there's a full web application framework to
 create dynamic web sites in C++ and XHTML.
 .
 This package contains the shared library only.
