=== debian/tests/control ===
Tests: run-build-test
Depends: build-essential, libzeep-dev
Restrictions: allow-stderr
