=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-#           Copyright Maarten L. Hekkelman, 2022
+#         Copyright Maarten L. Hekkelman, 2022-2026
 #  Distributed under the Boost Software License, Version 1.0.
 #     (See accompanying file LICENSE_1_0.txt or copy at
 #           http://www.boost.org/LICENSE_1_0.txt)
@@ -19,14 +19,14 @@
 endif()
 
 list(APPEND examples http-server-0 http-server-1 http-server-2 http-server-3
-	serialize-xml synopsis-json synopsis-xml validating-xml-sample xpath-sample
-	synopsis-el-1 security-sample rest-sample rest-sample-2	soap-sample)
+	security-sample rest-sample rest-sample-2 # soap-sample
+	)
 
 if (ZEEP_HAS_UNIX_DAEMON)
 	list(APPEND examples daemon-sample)
 endif()
 
 foreach(EXAMPLE IN LISTS examples)
-	add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
+	add_executable(${EXAMPLE} ${CMAKE_CURRENT_SOURCE_DIR}/${EXAMPLE}.cpp)
 	target_link_libraries(${EXAMPLE} zeep::zeep)
 endforeach()
