=== debian/changelog ===
libzeep (7.3.1-1) unstable; urgency=medium

  [ Maarten L. Hekkelman ]
  * New upstream version 7.3.1
    Closes: #1127227

  [ Andreas Tille ]
  * d/watch: version=5
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Sun, 22 Feb 2026 11:27:07 +0100
