=== debian/control ===
--- 
+++ 
@@ -1,20 +1,23 @@
 Source: libzeep
+Standards-Version: 4.7.3
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
-           Andreas Tille <tille@debian.org>
+Uploaders:
+ Maarten L. Hekkelman <maarten@hekkelman.com>,
+ Andreas Tille <tille@debian.org>,
 Section: libs
-Priority: optional
-Build-Depends: debhelper-compat (= 13),
-			   cmake,
-			   libboost-dev,
-			   libhowardhinnant-date-dev,
-			   libmcfp-dev,
-			   mrc,
-			   doxygen,
-			   python3-exhale,
-               python3-sphinx-rtd-theme,
-               python3-myst-parser
-Standards-Version: 4.7.0
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+ libzeem-dev,
+ libboost-dev,
+ libhowardhinnant-date-dev,
+ libmcfp-dev,
+ catch2,
+ mrc,
+ doxygen,
+ python3-exhale,
+ python3-sphinx-rtd-theme,
+ python3-myst-parser,
 Vcs-Browser: https://salsa.debian.org/med-team/libzeep
 Vcs-Git: https://salsa.debian.org/med-team/libzeep.git
 Homepage: https://github.com/mhekkel/libzeep
@@ -23,12 +26,16 @@
 Package: libzeep-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends},
-         libzeep6 (= ${binary:Version}),
-         libboost-dev,
-         libhowardhinnant-date-dev,
-         cmake
-Suggests: libzeep-doc, mrc
+Depends:
+ ${misc:Depends},
+ libzeep7 (= ${binary:Version}),
+ libzeem-dev,
+ libboost-dev,
+ libhowardhinnant-date-dev,
+ cmake,
+Suggests:
+ libzeep-doc,
+ mrc,
 Description: Development files for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as
@@ -50,8 +57,10 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}
-Suggests: libzeep-dev (>= ${binary:Version})
+Depends:
+ ${misc:Depends},
+Suggests:
+ libzeep-dev (>= ${binary:Version}),
 Description: Documentation for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as
@@ -69,10 +78,11 @@
  This specific package contains the documentation you can use to develop new
  software using libzeep.
 
-Package: libzeep6
+Package: libzeep7
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Library file for libzeep
  Libzeep is a C++ library providing a validating XML parser, XML DOM tree
  implementation, XPath 1.0 support and code to create SOAP/REST servers as
