## libzeep 7.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 cmake_minimum_required(VERSION 3.28)
 
-project(libzeep VERSION 7.3.1 LANGUAGES CXX)
+project(libzeep VERSION 7.3.2 LANGUAGES CXX)
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -149,6 +149,7 @@
 # Library rules
 file(GLOB_RECURSE zeep_cpp src/*.cpp)
 file(GLOB_RECURSE zeep_hpp include/*.hpp)
+list(APPEND zeep_hpp include/zeep/config.hpp)
 
 # TODO: SOAP is not working at the moment, really need to fix that
 list(FILTER zeep_cpp EXCLUDE REGEX src/soap-controller.cpp)
