=== docs/requirements.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
     # via requests
 imagesize==1.4.1
     # via sphinx
-jinja2==3.1.5
+jinja2==3.1.6
     # via
     #   myst-parser
     #   sphinx
@@ -55,7 +55,7 @@
     # via sphinx
 pyyaml==6.0.1
     # via myst-parser
-requests==2.32.0
+requests==2.32.4
     # via sphinx
 six==1.16.0
     # via exhale
@@ -89,5 +89,5 @@
     # via sphinx
 typing-extensions==4.7.1
     # via myst-parser
-urllib3==2.2.2
+urllib3==2.6.3
     # via requests
