=== debian/changelog ===
libzeep (7.3.2-3) unstable; urgency=medium

  * Disable daemon-test, since it does not work as expected.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 27 Feb 2026 09:42:40 +0100

libzeep (7.3.2-2) unstable; urgency=medium

  * Fixes daemon-test, use unique directory for storing PID file.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 26 Feb 2026 14:31:25 +0100

libzeep (7.3.2-1) unstable; urgency=medium

  [ Maarten L. Hekkelman ]
  * New upstream version 7.3.2
  * Fixes autopkgtest

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 26 Feb 2026 11:57:39 +0100
