=== debian/control ===
--- 
+++ 
@@ -59,6 +59,8 @@
 Section: doc
 Depends:
  ${misc:Depends},
+ libjs-jquery,
+ libjs-sphinxdoc
 Suggests:
  libzeep-dev (>= ${binary:Version}),
 Description: Documentation for libzeep
